// Models
import { YearMapping } from '@app/core/models/year';
import { DegreePlan } from '@app/core/models/degree-plan';
import { SavedForLaterCourse } from '@app/core/models/saved-for-later-course';
import { SubjectMapping } from '@app/core/models/course';

export interface DegreePlannerState {
  visibleDegreePlan: DegreePlan | undefined;
  visibleYears: YearMapping;
  savedForLaterCourses: SavedForLaterCourse[];
  activeTermCodes: string[];
  allDegreePlans: DegreePlan[];
  subjects: SubjectMapping;
  subjectDescriptions: SubjectMapping;
  expandedYears: string[];
  search: { visible: boolean; selectedTerm: string };
}

export const INITIAL_DEGREE_PLANNER_STATE: DegreePlannerState = {
  visibleDegreePlan: undefined,
  visibleYears: {},
  savedForLaterCourses: [],
  activeTermCodes: [],
  allDegreePlans: [],
  subjects: {},
  subjectDescriptions: {},
  expandedYears: [],
  search: { visible: false, selectedTerm: '0000' },
};
